
/**
 * Bitmap Internalizer
 * 
 * TunesRus90
 * 1-11-07
 */

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.io.*;
import java.util.*;
import java.util.prefs.*;
import java.nio.ByteOrder;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.KeyStroke.*;
import javax.swing.text.DefaultEditorKit;



public class EditorGUI extends JFrame implements ActionListener
{
    public RandomAccessFileSP raf;
    public RandomAccessFileSP mmRaf;
    public RandomAccessFileSP sharRaf;
    public RandomAccessFileSP spSharRaf;
    
    
    public File mapFile;
    
    JMenuItem open;
    JMenuItem close;
    JMenuItem exit;
    JMenuItem about;
    JMenuItem minimize;
    JMenuItem cut;
    JMenuItem copy;
    JMenuItem paste;
    JMenuItem clearPrefs;
    JMenuItem search;
    JMenuItem clearSearch;
    JMenuItem resign;
    JMenuItem internAll;
    JLabel bitmSizeLbl;
    JLabel bitmOffLbl;
    JLabel bitmTypeLbl;
    JLabel bitmLocLbl;
    JTextField bitmSizeTxt;
    JTextField bitmOffTxt;
    JTextField bitmTypeTxt;
    JTextField bitmLocTxt;
    JButton internBtn;
    JButton addBtn;
    JButton removeBtn;
    JButton clearBtn;
    JList tagList;
    JList chosenList;
    Preferences internPrefs;
    
    DefaultListModel tagListModel;
    DefaultListModel chosenListModel;
    ListSelectionListener selectionListener;
    
    public boolean mapLoaded = false;
    public static boolean isMac;
    public static String sysOS;
    public long BitmOffset;
    public long BitmSize;
    public long indexOffset;
    public long indexSize;
    public long mapSize;
    public long primaryMagic;
    public long secondaryMagic;
    public long tagsOffset;
    public int tagCount;
    public long fileTableOffset;
    public int fileTableSize;
    public int bitmTagsNum;
    public ArrayList<TagInstance> bitmTags;
    public ArrayList<TagInstance> searchResults;
    public TagInstance[] tags;
    public long timeStart;
    public long timeFinished;
    public long timeTaken;
    public String bitmFormat;
    public boolean isSearched = false;

    public String MapType;
       
    public EditorGUI()
    {
         super("Halo 2 Bitmap Internalizer");
         this.setSize(500,560);
         this.setLayout(null);
         this.setVisible(true);
         this.setJMenuBar(newMenuBar());
         
         internPrefs = Preferences.userNodeForPackage(this.getClass());
         String[] sharedPrefs = new String[3];
         sharedPrefs[0] = "Main Menu";
         sharedPrefs[1] = "Shared";
         sharedPrefs[2] = "SP Shared";
         for(int i = 0; i < 3; i++)
         {
            String sharedPath = internPrefs.get(sharedPrefs[i], null);
            if(sharedPath == null)
            {
                String filePath = setSharedPath(sharedPrefs[i]);
                if(filePath.equals("null"))
                {
                    JOptionPane.showMessageDialog(this, "Shared Map Opening Cancelled.", "Error", JOptionPane.ERROR_MESSAGE);
                    return;
                }
                else
                {
                    sharedPath = filePath;
                }
            }
         }
         
         bitmSizeLbl = new JLabel("Bitm Tag Size:");
         bitmSizeLbl.setBounds(20, 270, 120, 25);
         bitmSizeLbl.setHorizontalAlignment(JLabel.RIGHT);
         this.add(bitmSizeLbl);
         
         bitmSizeTxt = new JTextField();
         bitmSizeTxt.setBounds(145, 270, 100, 20);
         this.add(bitmSizeTxt);
         
         bitmOffLbl = new JLabel("Bitm Tag Offset:");
         bitmOffLbl.setBounds(20, 295, 120, 25);
         bitmOffLbl.setHorizontalAlignment(JLabel.RIGHT);
         this.add(bitmOffLbl);
         
         bitmOffTxt = new JTextField();
         bitmOffTxt.setBounds(145, 295, 100, 20);
         this.add(bitmOffTxt);
        
         bitmTypeLbl = new JLabel("Bitm Type:");
         bitmTypeLbl.setBounds(270, 270, 95, 25);
         bitmTypeLbl.setHorizontalAlignment(JLabel.RIGHT);
         this.add(bitmTypeLbl);
         
         bitmTypeTxt = new JTextField();
         bitmTypeTxt.setBounds(375, 270, 100, 20);
         this.add(bitmTypeTxt);
         
         bitmLocLbl = new JLabel("Bitm Location:");
         bitmLocLbl.setBounds(270, 295, 95, 25);
         bitmLocLbl.setHorizontalAlignment(JLabel.RIGHT);
         this.add(bitmLocLbl);
         
         bitmLocTxt = new JTextField();
         bitmLocTxt.setBounds(375, 295, 100, 20);
         this.add(bitmLocTxt);
         
         internBtn = new JButton("Internalize");
         internBtn.setBounds(295, 225, 130, 28);
         internBtn.addActionListener(this);
         this.add(internBtn);
         
         addBtn = new JButton("Add Tag");
         addBtn.setBounds(75, 225, 130, 28);
         addBtn.addActionListener(this);
         this.add(addBtn);
         
         removeBtn = new JButton("Remove Tag");
         removeBtn.setBounds(75, 475, 130, 28);
         removeBtn.addActionListener(this);
         this.add(removeBtn);
         
         clearBtn = new JButton("Clear Tags");
         clearBtn.setBounds(295, 475, 130, 28);
         clearBtn.addActionListener(this);
         this.add(clearBtn);
         
         tagListModel = new DefaultListModel();
         tagList = new JList(tagListModel);
         tagList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
         tagList.addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                if(!tagList.getValueIsAdjusting())
                {
                    Object c = tagList.getSelectedValue();
                    if(c instanceof TagInstance)
                    {
                        TagInstance selectedTag = (TagInstance)c;
                        bitmSizeTxt.setText(Integer.toString(selectedTag.tagSize));
                        bitmOffTxt.setText("0x" + Long.toHexString(selectedTag.tagOffset).toUpperCase());
                        bitmTypeTxt.setText(bitmFormat);
                        bitmLocTxt.setText(selectedTag.bitmChunks[0].rawLocation.name);
                    }
                }
            }});
         JScrollPane tagScrollPanel = new JScrollPane(tagList);
         tagScrollPanel.setBounds(15, 15, 470, 200);
         this.add(tagScrollPanel);
         
         chosenListModel = new DefaultListModel();
         chosenList = new JList(chosenListModel);
         chosenList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
         JScrollPane chosenScrollPanel = new JScrollPane(chosenList);
         chosenScrollPanel.setBounds(15, 335, 470, 130);
         this.add(chosenScrollPanel);
    }
       
    JMenuBar newMenuBar()
    {
        JMenuBar menuBar = new JMenuBar();
        
        JMenu file = new JMenu("File");
        open = new JMenuItem("Open");
        open.setAccelerator(KeyStroke.getKeyStroke('O',
            Toolkit.getDefaultToolkit(  ).getMenuShortcutKeyMask(  ), false));
        open.addActionListener(this);
        file.add(open);
        
        file.addSeparator();
        
        close = new JMenuItem("Close");
        close.addActionListener(this);
        close.setAccelerator(KeyStroke.getKeyStroke('W',
            Toolkit.getDefaultToolkit(  ).getMenuShortcutKeyMask(  ), false));
        file.add(close);
        
        JMenu edit = new JMenu("Edit");
        
        cut = new JMenuItem(new DefaultEditorKit.CutAction());
        cut.setText("Cut");
        cut.setAccelerator(KeyStroke.getKeyStroke('X',
            Toolkit.getDefaultToolkit(  ).getMenuShortcutKeyMask(  ), false));
        edit.add(cut);
        
        copy = new JMenuItem(new DefaultEditorKit.CopyAction());
        copy.setText("Copy");
        copy.setAccelerator(KeyStroke.getKeyStroke('C',
            Toolkit.getDefaultToolkit(  ).getMenuShortcutKeyMask(  ), false));
        edit.add(copy);
        
        paste = new JMenuItem(new DefaultEditorKit.PasteAction());
        paste.setText("Paste");
        paste.setAccelerator(KeyStroke.getKeyStroke('V',
            Toolkit.getDefaultToolkit(  ).getMenuShortcutKeyMask(  ), false));
        edit.add(paste);
        
        edit.addSeparator();
        
        search = new JMenuItem("Search");
        search.addActionListener(this);
        edit.add(search);
        
        clearSearch = new JMenuItem("Reset Tag List");
        clearSearch.addActionListener(this);
        edit.add(clearSearch);
        
        edit.addSeparator();
        
        internAll = new JMenuItem("Internalize All Bitmaps");
        internAll.addActionListener(this);
        edit.add(internAll);
        
        edit.addSeparator();
        
        clearPrefs = new JMenuItem("Clear Shared Map Paths");
        clearPrefs.addActionListener(this);
        edit.add(clearPrefs);
        
        resign = new JMenuItem("Resign Map");
        resign.addActionListener(this);
        edit.add(resign);
        
        //OSX Specific GUI Code
        if(isMac)
        {
            JMenu window = new JMenu("Window");
            
            minimize = new JMenuItem("Minimize");
            minimize.setAccelerator(KeyStroke.getKeyStroke('M',
                Toolkit.getDefaultToolkit(  ).getMenuShortcutKeyMask(  ), false));
            minimize.addActionListener(this);
            window.add(minimize);
            
            menuBar.add(file);
            menuBar.add(edit);
            menuBar.add(window);
        }
        else
        {
            exit = new JMenuItem("Exit");
            exit.addActionListener(this);
            file.add(exit);
            
            JMenu help = new JMenu("Help");
            
            about = new JMenuItem("About");
            about.addActionListener(this);
            help.add(about);
            
            menuBar.add(file);
            menuBar.add(edit);
            menuBar.add(help);
        }
        return menuBar;
    }
    
    public void actionPerformed(ActionEvent event)
    {
        if(event.getSource() == this.exit)
        {
            System.exit(0);
        }
        
        else if(event.getSource() == this.close)
        {
            try
            {
                if(mapLoaded)
                {
                    raf.close();
                    tagListModel.removeAllElements();
                    chosenListModel.removeAllElements();
                    bitmSizeTxt.setText("");
                    bitmOffTxt.setText("");
                    bitmTypeTxt.setText("");
                    bitmLocTxt.setText("");
                    bitmTags.clear();
                    mapLoaded = false;
                    this.setTitle("Halo 2 Bitmap Internalizer");
                }
                else
                {
                    JOptionPane.showMessageDialog(this, "No File Open", "Error", JOptionPane.ERROR_MESSAGE);
                }
            }
            catch (Exception ex)
            {
                System.out.println(ex);
                ex.printStackTrace();
                JOptionPane.showMessageDialog(this, "Error Closing File.", "Error", JOptionPane.ERROR_MESSAGE);
            }   
        }
        
        else if(event.getSource() == this.open)
        {
            try
            {
                if(!mapLoaded)
                {
                    String mapPath = internPrefs.get("Last_Loaded_Map", null);
                    if(isMac)
                    {
                        FileDialog chooser = new FileDialog(this, "Open Map", FileDialog.LOAD);
                        /*chooser.setFilenameFilter(new FilenameFilter(){
                            public void accept(File dir, String name){
                              return (name.endsWith(".map"));
                            }
                        });*/
                        if(mapPath != null)
                            {chooser.setDirectory(mapPath);}
                        chooser.setVisible(true);
                        if(chooser.getFile() != null)
                        {
                            String file = chooser.getDirectory() + chooser.getFile();
                            mapFile = new File(file);
                            internPrefs.put("Last_Loaded_Map", chooser.getDirectory());
                            loadMap(mapFile);
                            this.setTitle("Halo 2 Bitmap Internalizer - " + chooser.getFile());
                            mapLoaded = true;
                        }
                    }
                    else
                    {
                        JFileChooser chooser = new JFileChooser();
                        if(mapPath != null)
                        {
                            File mapDir = new File(mapPath);
                            chooser.setCurrentDirectory(mapDir);
                        }
                        chooser.setFileFilter(new MapFilter());
                        int result = chooser.showOpenDialog(null);
                        if(result == JFileChooser.APPROVE_OPTION)
                        {
                            mapFile = chooser.getSelectedFile();
                            internPrefs.put("Last_Loaded_Map", mapFile.getParent());
                            if(mapFile != null)
                            {
                                loadMap(mapFile);
                                this.setTitle("Halo 2 Bitmap Internalizer - " + chooser.getName());
                                mapLoaded = true;
                            }
                        }
                    }
                }
                else
                {
                    JOptionPane.showMessageDialog(this, "There already is an open map. Close that map first.", "Error", JOptionPane.ERROR_MESSAGE);
                }
            }
            catch (Exception ex)
            {
                System.out.println(ex);
                ex.printStackTrace();
                JOptionPane.showMessageDialog(this, "Error creating open dialogue", "Error", JOptionPane.ERROR_MESSAGE);
            }
        }
        
        else if(event.getSource() == this.minimize)
        {
            this.setExtendedState(ICONIFIED);
        }
        
        else if(event.getSource() == this.addBtn)
        {
            if(!mapLoaded){
                JOptionPane.showMessageDialog(this, "No map is currently open.", "Error", JOptionPane.ERROR_MESSAGE);
                return;
            }
            
            if(tagList.getSelectedValue() == null)
            {
                JOptionPane.showMessageDialog(this, "No tag is selected.\nPlease select a tag from the top list.", "No Tag Selected", JOptionPane.ERROR_MESSAGE);
            }
            else
            {
                Object c = tagList.getSelectedValue();
                int indexNum = tagList.getSelectedIndex();
                tagListModel.removeElement(c);
                tagList.setSelectedIndex(indexNum);
                if(c instanceof  TagInstance)
                {
                    TagInstance selectedTag = (TagInstance)c;
                    if(selectedTag.isAdded){
                        JOptionPane.showMessageDialog(this, "This tag is already in the list.", "Error", JOptionPane.ERROR_MESSAGE);}
                    else 
                    {
                    	boolean cer = false;
                    	for(int i = 0; i < selectedTag.bitmChunks.length; i++){
                    		if(selectedTag.bitmChunks[i].rawLocation != RawLocation.THIS_MAP){
                    			cer = true;
                    			break;
                    		}
                    	}
                    	if(!cer)
                    	{
                    		JOptionPane.showMessageDialog(this, "This tag contains no external Raw", "Error", JOptionPane.ERROR_MESSAGE);
                    	}
                    	else
                    	{
                            chosenListModel.addElement(selectedTag);
                            selectedTag.isAdded = true;
                        }
                    }
                }
                else
                {
                    JOptionPane.showMessageDialog(this, "Something is seriously screwed up.", "Error", JOptionPane.ERROR_MESSAGE);
                }
            }
        }
        
        else if(event.getSource() == this.removeBtn)
        {
            if(!mapLoaded){
                JOptionPane.showMessageDialog(this, "No map is currently open.", "Error", JOptionPane.ERROR_MESSAGE);
                return;
            }
            
            if(chosenList.getSelectedValue() == null){
                JOptionPane.showMessageDialog(this, "No tag selected.\nPlease select a tag from the bottom list", "No Tag Selected", JOptionPane.ERROR_MESSAGE);
                return;}
            
            int selectionIndex = chosenList.getSelectedIndex();
            Object c = chosenList.getSelectedValue();
            TagInstance selectedTag = (TagInstance)c;
            selectedTag.isAdded = false;
            if(!isSearched)
            {
                int indexNum = bitmTags.indexOf(c);
                tagListModel.add(indexNum, selectedTag);
            }
            else
            {
                boolean found = false;
                for(int i = 0; i < tagListModel.getSize(); i++)
                {
                    int result = selectedTag.compareTo(tagListModel.get(i));
                    if(result <= 0 && searchResults.contains(selectedTag))
                    {
                        tagListModel.add(i, selectedTag);
                        found = true;
                        break;
                    }
                }
                if(!found && searchResults.contains(selectedTag))
                {
                    tagListModel.add(tagListModel.getSize(), selectedTag);
                }                    
            }
            chosenListModel.removeElement(selectedTag);
            chosenList.setSelectedIndex(selectionIndex);
        }
        
        else if(event.getSource() == this.clearBtn)
        {
            if(!mapLoaded){
                JOptionPane.showMessageDialog(this, "No map is currently open.", "Error", JOptionPane.ERROR_MESSAGE);
                return;
            }
            
            for(int i = 0; i < chosenListModel.getSize(); i++)
            {
                Object c = chosenListModel.get(i);
                TagInstance selectedTag = (TagInstance)c;
                selectedTag.isAdded = false;
                if(!isSearched)
                {
                    tagListModel.add(bitmTags.indexOf(c), selectedTag);
                }
                else
                {
                    boolean found = false;
                    for(int j = 0; j < tagListModel.getSize(); j++)
                    {
                        int result = selectedTag.compareTo(tagListModel.get(j));
                        if(result <= 0 && searchResults.contains(selectedTag))
                        {
                            tagListModel.add(j, selectedTag);
                            found = true;
                            break;
                        }
                    }
                    if(!found && searchResults.contains(selectedTag))
                    {
                        tagListModel.add(tagListModel.getSize(), selectedTag);
                    }
                }                    
            }
            chosenListModel.removeAllElements();
        }
        
        else if(event.getSource() == this.internBtn)
        {
            if(!mapLoaded){
                JOptionPane.showMessageDialog(this, "No map is currently open.", "Error", JOptionPane.ERROR_MESSAGE);
                return;
            }
            
            internalize();
        }
        
        else if(event.getSource() == this.clearPrefs)
        {
            try
            {
                internPrefs.remove("Main Menu");
                internPrefs.remove("Shared");
                internPrefs.remove("SP Shared");
            }
            catch (Exception ex)
            {
                System.out.println(ex);
                ex.printStackTrace();
                JOptionPane.showMessageDialog(this, "Error clearing shared map locations.", "Error", JOptionPane.ERROR_MESSAGE);
            }
        }
        
        else if(event.getSource() == this.search)
        {
            if(!mapLoaded){
                JOptionPane.showMessageDialog(this, "No map is currently open.", "Error", JOptionPane.ERROR_MESSAGE);
                return;
            }
            
            searchResults = new ArrayList<TagInstance>();
            String input = JOptionPane.showInputDialog("Enter all or part of the tag name.");
			if(input != null)
			{
				int found = 0;
				tagListModel.clear();
				for(int i = 0; i < tagCount; i++)
				{
					int result = tags[i].tagName.indexOf(input);
					if(result != -1 && tags[i].isExternal && !tags[i].isAdded)
					{
						found += 1;
						searchResults.add(tags[i]);
					}
				}
				if(found == 0)
				{
				    JOptionPane.showMessageDialog(this, "No Results Found", "Error", JOptionPane.ERROR_MESSAGE);
				    return;
				}
				isSearched = true;
				Collections.sort(searchResults);
                for(int i = 0; i < found; i++)
                {
                    tagListModel.addElement(searchResults.get(i));
                }
			}
			else
			{
				JOptionPane.showMessageDialog(this, "Please enter text.", "Error", JOptionPane.ERROR_MESSAGE);
			}
        }
        
        else if(event.getSource() == this.resign)
        {
            if(!mapLoaded){
                JOptionPane.showMessageDialog(this, "No map is currently open.", "Error", JOptionPane.ERROR_MESSAGE);
                return;
            }
            
            try
            {
                long oldSig = raf.getUInt(720);
    			long pos = 2048;
    			//default buffer size alter and view time difference
    			int defaultBufferSize = 20000000;
    			long newSig = 0;
    			while(pos != mapSize)
    			{
    				int bufferSize = 0;
    				if(mapSize - pos >= defaultBufferSize)
    				{
    					bufferSize = defaultBufferSize;
    				}
    				else
    				{
    					bufferSize = (int)(mapSize - pos);
    				}
    				//buffer then read uint ints
    				raf.buffer(pos, bufferSize);
    				for(int i = 0; i < bufferSize; i = i + 4){
    					newSig ^= raf.getBuffedUInt();
    				}
    				pos = pos + bufferSize;
    			}
    			raf.putUInt(720, newSig);
    			JOptionPane.showMessageDialog(null, "Sig succesfully written!\n" + "Old Sig = 0x" + Long.toHexString(oldSig).toUpperCase()
						+ "\nNew Sig = 0x" + Long.toHexString(newSig).toUpperCase(), "Complete", JOptionPane.INFORMATION_MESSAGE);
            }
            catch (Exception ex)
            {
                System.out.println(ex);
                ex.printStackTrace();
                JOptionPane.showMessageDialog(this, "Error resigning map.", "Error", JOptionPane.ERROR_MESSAGE);
            }            
        }
        
        else if(event.getSource() == this.clearSearch)
        {
            if(!mapLoaded){
                JOptionPane.showMessageDialog(this, "No map is currently open.", "Error", JOptionPane.ERROR_MESSAGE);
                return;
            }
            searchResults.clear();            
            tagListModel.clear();
            for(int i = 0; i < bitmTagsNum; i++)
            {
                tagListModel.addElement(bitmTags.get(i));
            }
            isSearched = false;
        }
        
        else if(event.getSource() == this.internAll)
        {
            if(!mapLoaded){
                JOptionPane.showMessageDialog(this, "No map is currently open.", "Error", JOptionPane.ERROR_MESSAGE);
                return;
            }
            
            for(int i = 0; i < bitmTagsNum; i++)
            {
                chosenListModel.addElement(tagListModel.getElementAt(i));
            }
            tagListModel.removeAllElements();
            internalize();
        }
        
        else if(event.getSource() == this.about)
        {
            JOptionPane.showMessageDialog(this, "Created By: TunesRus90\n\n" + 
                                                "Thanks To:\n" +
                                                "Chiefdestroyer - source and help\n" +
                                                "Punk - testing and suggestions\n" +
                                                "All other testers and helpers");
        }
    }
    
    void loadMap(File mapFile)
    {
        try
        {
            raf = new RandomAccessFileSP(mapFile, "rw"); 
            raf.setByteOrder(ByteOrder.LITTLE_ENDIAN);
 
            timeStart = System.currentTimeMillis();
            
            mapSize = raf.getUInt(8);
            indexOffset = raf.getUInt(16);
            indexSize = raf.getUInt(20);
            fileTableOffset = raf.getUInt(708);
            fileTableSize = raf.getInt(712);
            System.out.println("Map Size: " + mapSize + 
                "\nIndexOffset: " + indexOffset + 
                "\nIndex Size: " + indexSize + 
                "\nFile Table Offset: " + fileTableOffset + 
                "\nFile Table Size: " + fileTableSize);
            
            //Start of primary magic finder
            primaryMagic = (raf.getUInt(indexOffset)) - (indexOffset + 32);
            String PrimaryMagic = Long.toHexString(primaryMagic);
            System.out.println("The Primary Magic is = 0x" + PrimaryMagic.toUpperCase());
            //End of primary magic finder
            
            //Start of Secondary Magic
            secondaryMagic = raf.getUInt((raf.getUInt(indexOffset + 8)- primaryMagic) + 8) - (indexOffset + indexSize);
            String SecondaryMagic = Long.toHexString(secondaryMagic);
            System.out.println("The Secondary Magic = 0x" + SecondaryMagic.toUpperCase());
            //End of Secondary Magic
            
            tagsOffset = indexOffset + 32 + (raf.getUInt(indexOffset + 4) * 12);
            tagCount = raf.getInt(indexOffset + 24);   
            System.out.println("Number of Tags: " + tagCount);
            
            //Load All Tags into array tags[]
            raf.buffer(tagsOffset, tagCount*16);
            tags = new TagInstance[tagCount];
            bitmTagsNum = 0;
            for(int i = 0; i < tagCount; i++)
            {
                tags[i] = new TagInstance();
                tags[i].tagType = raf.getBuffedString(4, true);
                tags[i].tagID = raf.getBuffedUInt();
                tags[i].tagOffset = raf.getBuffedUInt() - secondaryMagic;
                tags[i].tagSize = raf.getBuffedInt();
                if(tags[i].tagType.equals("bitm"))
                {
                    tags[i].isBitm = true;
                    bitmTagsNum += 1;
                }
                else
                {
                    tags[i].isBitm = false;
                }
            }
            
            //Load Tag Names and store bitmap tag names to a seperate array also.
            System.out.println("bitmTagsNum: " + bitmTagsNum);
            raf.buffer(fileTableOffset, fileTableSize);
            for(int i = 0; i < tagCount; i++)
            {
                tags[i].tagName = raf.getBuffedString();
            }
            
            //Analyze all bitm tags and add to ArrayList if external.
            bitmTags = new ArrayList<TagInstance>();
            for(int i = 0; i < tagCount; i++)
            {
                if(tags[i].isBitm)
                {
                    tags[i].isExternal = true;
                    bitmSelected(tags[i]);
                    //loop for each chunk
                    for(int j = 0; j < tags[i].bitmChunkCount; j++)
                    {
                        if(tags[i].bitmChunks[j].rawLocation == RawLocation.THIS_MAP)
                        {
                            tags[i].isExternal = false;
                            bitmTagsNum -= 1;
                            break;
                        }
                	}
                	if(tags[i].isExternal)
                	{
                	    bitmTags.add(tags[i]);
            	   }
                }
            }                
            
            //Sort Bitmap Tags Array and add to List
            Collections.sort(bitmTags);
            for(int i = 0; i < bitmTagsNum; i++)
            {
                tagListModel.addElement(bitmTags.get(i));
            }
            
            if(tagListModel.getSize() == 0)
            {
                JOptionPane.showMessageDialog(this, "This map contains no external bitmaps.", "No External Bitmaps", JOptionPane.ERROR_MESSAGE);
            }
            
            timeFinished = System.currentTimeMillis();
            timeTaken = timeFinished - timeStart;
            System.out.println("Load Map Completed in " + timeTaken + " milliseconds");

        }
        catch (Exception ex)
        {
            System.out.println(ex);
            ex.printStackTrace();
            JOptionPane.showMessageDialog(this, "Cannot read from File.", "Error", JOptionPane.ERROR_MESSAGE);
        }
        
    }
    
   void bitmSelected(TagInstance selectedTag)
    {
        try
        {
            raf.buffer(selectedTag.tagOffset, selectedTag.tagSize);
            selectedTag.bitmChunkCount = raf.getBuffedUShort(68);
            selectedTag.bitmChunks = new BitmChunk[selectedTag.bitmChunkCount];
            //pointerFTS = Pointer From Tag Start
            int pointerFTS = (int)(raf.getBuffedUInt(72) - secondaryMagic - selectedTag.tagOffset);
            
            for(int i=0; i < selectedTag.bitmChunkCount; i++)
            {
                selectedTag.bitmChunks[i] = new BitmChunk();
                selectedTag.bitmChunks[i].chunkOffset = pointerFTS+(i*116);
                //System.out.println("Chunk Offset: " + selectedTag.bitmChunks[i].chunkOffset);
                selectedTag.bitmChunks[i].formatValue = raf.getBuffedUShort((int)(selectedTag.bitmChunks[i].chunkOffset + 12));
                switch(selectedTag.bitmChunks[i].formatValue)
                {
                    case 0:
                        bitmFormat = "A8";
                        break;
                    case 1:
                        bitmFormat = "Y8";
                        break;
                    case 2:
                        bitmFormat = "AY8";
                        break;
                    case 3:
                        bitmFormat = "A8Y8";
                        break;
                    case 6:
                        bitmFormat = "R5G6B5";
                        break;
                    case 8:
                        bitmFormat = "A1R5G5B5";
                        break;
                    case 9:
                        bitmFormat = "A4R4G4B4";
                        break;
                    case 10:
                        bitmFormat = "X8R8G8B8";
                        break;
                    case 11:
                        bitmFormat = "A8R8G8B8";
                        break;
                    case 14:
                        bitmFormat = "DXT 1";
                        break;
                    case 15:
                        bitmFormat = "DXT 2/3";
                        break;
                    case 16:
                        bitmFormat = "DXT 4/5";
                        break;
                    case 17:
                        bitmFormat = "P8";
                        break;
                    default:
                        bitmFormat = "Unkown";
                        break;
                }
                
                //Get LOD count
                long tempRawPointer;
                int tempSize;
                for(int j = 0; j < 6; j++)
                {
                    tempRawPointer = raf.getBuffedUInt(selectedTag.bitmChunks[i].chunkOffset + 28 + (j * 4));
                    tempSize = raf.getBuffedInt(selectedTag.bitmChunks[i].chunkOffset + 52 + (j * 4));
                    if(tempRawPointer == 0xFFFFFFFFL){
                        break;
                    }
                    selectedTag.bitmChunks[i].lods.add(new BitmChunk.LOD(tempRawPointer, tempSize));
                }
                //trim to size does not have to be done on an arraylist but will save a tiny amount of space
                //should only be done after you know you have no more elements to go in the arraylist
                selectedTag.bitmChunks[i].lods.trimToSize();
                //System.out.println("LOD Count: " + selectedTag.bitmChunks[i].lods.size());
                selectedTag.bitmChunks[i].rawLocation = RawLocation.getRawLocation(selectedTag.bitmChunks[i].lods.get(0).rawPointer);
            }
         }
         catch (Exception ex)
         {
             System.out.println(ex);
             ex.printStackTrace();
             JOptionPane.showMessageDialog(this, "Error Reading Bitmap.", "Error", JOptionPane.ERROR_MESSAGE);
         }
    }
    
    void internalize()
    {
    	HashMap<RawLocation, RandomAccessFileSP> sharedMaps = new HashMap<RawLocation, RandomAccessFileSP>();
    	HashMap<RawLocation, Boolean> sharedNeeds = new HashMap<RawLocation, Boolean>();
    	
        try
        {
            if(chosenListModel.getSize() == 0)
            {
                JOptionPane.showMessageDialog(this, "No tags are selected.\nPlease add tags to the bottom list.", "Error", JOptionPane.ERROR_MESSAGE);
        		return;
            }
        	
            timeStart = System.currentTimeMillis();
            for(int i=0; i < chosenListModel.getSize(); i++)
            {
                TagInstance selectedTag = (TagInstance)chosenListModel.get(i);
                for(int j = 0; j < selectedTag.bitmChunks.length; j++){
                	RawLocation rl = selectedTag.bitmChunks[j].rawLocation;
                	if(rl != RawLocation.THIS_MAP){
                		sharedNeeds.put(rl, true);
                	}
                }
               
            }//end of tag analyzing/preference creating loop
            
            ///gather needs
            RawLocation[] needs = sharedNeeds.keySet().toArray(new RawLocation[0]);
            for(int i = 0; i < needs.length; i++)
            {
                String sharedPath = internPrefs.get(needs[i].name, null);
                if(sharedPath == null)
                {
                    String filePath = setSharedPath(needs[i].name);
                    if(filePath.equals("null")){
                        JOptionPane.showMessageDialog(this, "Internalizing Cancelled", "Error", JOptionPane.ERROR_MESSAGE);
                        return;
                    }
                    else{
                        sharedPath = filePath;
                    }
                }
                
                try
                {
            		File sharedFile = new File(sharedPath);
            		if(!sharedFile.exists())
            		{
            		    String filePath = setSharedPath(needs[i].name);
                        if(filePath.equals("null"))
                        {
                            JOptionPane.showMessageDialog(this, "Internalizing Cancelled", "Error", JOptionPane.ERROR_MESSAGE);
                            return;
                        }
                        else
                        {
                            sharedFile = new File(filePath);
                        }
                    }
            		RandomAccessFileSP sharedRAF = new RandomAccessFileSP(sharedFile,"rw");
            		sharedMaps.put(needs[i], sharedRAF);
            	}
            	catch(Exception ex)
            	{
            		JOptionPane.showMessageDialog(this, "Failed to Open Shared Map : " + sharedPath + "\now aborting", "Error", JOptionPane.ERROR_MESSAGE);
            		return;
            	}
            }
            
            //total up raw size and create room
            long rawSize = 0;
            //loop for each tag
            for(int i=0; i < chosenListModel.getSize(); i++)
            {
                TagInstance selectedTag = (TagInstance)chosenListModel.get(i);
                //loop for each chunk
                for(int j=0; j < selectedTag.bitmChunkCount; j++)
                {
                	if(selectedTag.bitmChunks[j].rawLocation != RawLocation.THIS_MAP)
                	{
                        //loop for each LOD
                        for(int k=0; k < selectedTag.bitmChunks[j].lods.size(); k++)
                        {
                            rawSize += selectedTag.bitmChunks[j].lods.get(k).rawSize;
                            rawSize += genPaddingSize(selectedTag.bitmChunks[j].lods.get(k).rawSize, 512);
                        }
                	}
                }
            }
            System.out.println("Total Raw Size: " + rawSize);
            raf.shift(indexOffset, rawSize);
            
            //Write Raw Data
            long offsetInShared;
            long offsetToWrite = indexOffset;
            raf.seek(offsetToWrite);
            byte[] rawData;
            //loop for each tag
            int tempRawSize;
            for(int i=0; i < chosenListModel.getSize(); i++)
            {
                TagInstance selectedTag = (TagInstance)chosenListModel.get(i);
                //loop for each chunk
                for(int j=0; j < selectedTag.bitmChunkCount; j++)
                {
                	if(selectedTag.bitmChunks[j].rawLocation != RawLocation.THIS_MAP)
                	{
                        //loop for each LOD
                        for(int k=0; k < selectedTag.bitmChunks[j].lods.size(); k++)
                        {
                        	tempRawSize = selectedTag.bitmChunks[j].lods.get(k).rawSize;
                            offsetInShared = RawLocation.getOffsetInSharedMap(selectedTag.bitmChunks[j].lods.get(k).rawPointer);                        
                            rawData = new byte[tempRawSize];
                            RandomAccessFileSP shared = sharedMaps.get(selectedTag.bitmChunks[j].rawLocation);
                            
                            //reads the data into the array
                            shared.seek(offsetInShared);
                            shared.read(rawData);
                            
                            raf.write(rawData);
                            //writes padding after chunk
                            int paddingSize = genPaddingSize(tempRawSize, 512);
                            raf.write(genPadding(paddingSize, (byte)0));
                            selectedTag.bitmChunks[j].lods.get(k).rawPointer = RawLocation.setRawLocation(offsetToWrite, RawLocation.THIS_MAP);
                            offsetToWrite += tempRawSize + paddingSize;
                        }
                	}
                }
                selectedTag.isAdded = false;
                selectedTag.isExternal = false;
                bitmTagsNum -= 1;
                bitmTags.remove(bitmTags.indexOf(selectedTag));
                if(tagListModel.contains(selectedTag))
                {
                    tagListModel.removeElement(tagListModel.indexOf(selectedTag));
                }
            }
            
            //fixing pointers
            for(int i = 0; i < chosenListModel.getSize(); i++)
            {
            	TagInstance selectedTag = (TagInstance)chosenListModel.get(i);
            	for(int j = 0; j < selectedTag.bitmChunkCount; j++)
            	{
        			for(int k = 0; k < selectedTag.bitmChunks[j].lods.size(); k++)
        			{
            			raf.putUInt(selectedTag.tagOffset + rawSize + selectedTag.bitmChunks[j].chunkOffset + 28 + (k * 4), selectedTag.bitmChunks[j].lods.get(k).rawPointer);
        			}
            	}
            }
            
            //Write back all changed values
            mapSize += rawSize;
            indexOffset += rawSize;
            raf.putUInt(8, mapSize);
            raf.putUInt(16, indexOffset);
            
            //Start of primary magic finder
            primaryMagic = (raf.getUInt(indexOffset)) - (indexOffset + 32);
            String PrimaryMagic = Long.toHexString(primaryMagic);
            System.out.println("The Primary Magic is = 0x" + PrimaryMagic.toUpperCase());
            //End of primary magic finder
            
            //Start of Secondary Magic
            secondaryMagic = raf.getUInt((raf.getUInt(indexOffset + 8)- primaryMagic) + 8) - (indexOffset + indexSize);
            String SecondaryMagic = Long.toHexString(secondaryMagic);
            System.out.println("The Secondary Magic = 0x" + SecondaryMagic.toUpperCase());
            //End of Secondary Magic
            
            //Find new tagsOffset
            tagsOffset = indexOffset + 32 + (raf.getUInt(indexOffset + 4) * 12);
            
            for(int i = 0; i < tagCount; i++)
            {
                tags[i].tagOffset += rawSize;
            }
            
            int finalNum = chosenListModel.getSize();
            chosenListModel.clear();
            
            timeFinished = System.currentTimeMillis();
            timeTaken = timeFinished - timeStart;
            JOptionPane.showMessageDialog(this, "Complete!" +
                "\nInternalized " + finalNum + " bitmap(s) in" +
                "\n" + timeTaken + " milliseconds.", "Complete", JOptionPane.INFORMATION_MESSAGE);
        }
            
        catch (Exception ex)
        {
            System.out.println(ex);
            ex.printStackTrace();
            JOptionPane.showMessageDialog(this, "Error Shifting Data.", "Error", JOptionPane.ERROR_MESSAGE);
        }
    }
    
    String setSharedPath(String key)
    {
        if(isMac)
        {
            FileDialog chooser = new FileDialog(this, "Open " + key, FileDialog.LOAD);
            chooser.setVisible(true);
            if(chooser.getFile() != null)
            {
                String filePath = chooser.getDirectory() + chooser.getFile();
                internPrefs.put(key, filePath);
                return filePath;
            }
            else
            {
                return "null";
            }
        }
        else
        {
            JFileChooser chooser = new JFileChooser();
            chooser.setFileFilter(new MapFilter());
            chooser.setDialogTitle("Open " + key);
            int result = chooser.showOpenDialog(null);
            if(result == JFileChooser.APPROVE_OPTION)
            {
                String filePath = chooser.getSelectedFile().getPath();
                internPrefs.put(key, filePath);
                return filePath;
            }
            else
            {
                return "null";
            }
        }   
    }
    
    int genPaddingSize(long totRawSize, int padToSize)
    { 
        long paddingSize = padToSize - (totRawSize % padToSize); 
        if(paddingSize == padToSize)
        { 
            paddingSize = 0; 
        } 
        return (int)paddingSize; 
    }
    
    byte[] genPadding(int amount, byte type){
    	byte[] padding = new byte[amount];
    	for(int i = 0; i < amount; i++){
    		padding[i] = type;
    	}
    	return padding;
    }
    
    public static void main(String[] args) 
    {
        try
        {
            sysOS = System.getProperty("os.name").toLowerCase();
            if(sysOS.startsWith("mac os x"))
            {
                isMac = true;
                System.setProperty("apple.laf.useScreenMenuBar", "true");
            }
            else
            {
                isMac = false;
                UIManager.setLookAndFeel(
                UIManager.getSystemLookAndFeelClassName());
            }
        }
        catch (Exception ex)
        {
            System.out.println("Error in main class");
        }
        
        EditorGUI main = new EditorGUI();
        main.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        main.setLocationRelativeTo(null);
        main.setResizable(false);
        main.setVisible(true);
    }
}