
public enum RawLocation {
	THIS_MAP("Internal", 0),
	MAIN_MENU("Main Menu", 1),
	MULTI_PLAYER_SHARED("Shared", 2),
	SINGLE_PLAYER_SHARED("SP Shared", 3);
	public String name;
	public int id;
	RawLocation(String name, int id){
		this.name = name;
		this.id = id;
	}
	
	public static RawLocation getRawLocationByTopTwoBits(int bits){
		switch(bits){
		case 0:
			return THIS_MAP;
		case 1:
			return MAIN_MENU;
		case 2:
			return MULTI_PLAYER_SHARED;
		case 3:
			return SINGLE_PLAYER_SHARED;
		default:
			//wtf
			return null;
		}
	}
	
	public static RawLocation getRawLocation(long offset){
		//int map = (int)(((offset >> 31) & 1) << 1 | ((offset >> 30)& 1));
		int map = (int)((offset >> 30) & 3);
		return getRawLocationByTopTwoBits(map);
	}
	
	public static long getOffsetInSharedMap(long offset){
		return (0x3FFFFFFF & offset);
	}
	
	public static long setRawLocation(long offset, RawLocation rawLocation){
		int id = rawLocation.id;
		long newOffset =  ((id & 3) << 30) | (offset & 0x3FFFFFFF);
		return (newOffset & 0xFFFFFFFF);
	}
}
